# Getestet mit Python 3.11.6 und PySide 6.5.3

import sys
import random
import locale
import time
import PySide6.QtWidgets as widgets
import PySide6.QtUiTools as uic

# Viele rote Kringel, weil die Typen erst bekannt sind, wenn der QUiLoader gelaufen ist.
# Man könnte mit typing.cast abhelfen, aber das wird unübersichtlich.

# etwas wie 0,5*sin(42,13) zufällig erzeugen
def aufgabeErzeugen():
    zeitNehmen()
    f = open("rechner.csv", "a")
    f.write(daten + "\n")
    f.close()
    s = str(random.randint(0,9))
    s += ","
    s += str(random.randint(0,9))
    s += random.choice(["*", "/", "+", "-"])
    s += random.choice(["sin", "cos", "tan", "exp"])
    s += "("
    s += str(random.randint(1,9))
    s += str(random.randint(0,9))
    s += ","
    s += str(random.randint(0,9))
    s += str(random.randint(0,9))
    s += ")"
    w.ausgabe.setText(s)

t = 0
daten = ""

def zeitnahmeStarten():
    global t, daten
    t = time.perf_counter()
    daten = ""

def zeitNehmen():
    global t, daten
    s = time.perf_counter()
    d = s - t
    t = s
    daten += locale.str(d) + ";"
    #w.ausgabe.setText(daten)
    
app = widgets.QApplication(sys.argv)
locale.setlocale(locale.LC_ALL, "")

w = uic.QUiLoader().load("rechner.ui")
w.bGleich.clicked.connect(aufgabeErzeugen)
w.los.clicked.connect(zeitnahmeStarten)
w.b0.clicked.connect(zeitNehmen)
w.b1.clicked.connect(zeitNehmen)
w.b2.clicked.connect(zeitNehmen)
w.b3.clicked.connect(zeitNehmen)
w.b4.clicked.connect(zeitNehmen)
w.b5.clicked.connect(zeitNehmen)
w.b6.clicked.connect(zeitNehmen)
w.b7.clicked.connect(zeitNehmen)
w.b8.clicked.connect(zeitNehmen)
w.b9.clicked.connect(zeitNehmen)
w.sin.clicked.connect(zeitNehmen)
w.cos.clicked.connect(zeitNehmen)
w.tan.clicked.connect(zeitNehmen)
w.exp.clicked.connect(zeitNehmen)
w.bPlus.clicked.connect(zeitNehmen)
w.bMin.clicked.connect(zeitNehmen)
w.bMul.clicked.connect(zeitNehmen)
w.bDiv.clicked.connect(zeitNehmen)
w.bKomma.clicked.connect(zeitNehmen)

aufgabeErzeugen()
w.show()
sys.exit(app.exec())